﻿Public Class frmRun
    Dim bytArray(0) As Byte
    Dim lngPointer As Long = 0
    Dim strCode As String = frmCodeInput.rtbCode.Text
    
    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        For lngCodePtr As Long = 0 To strCode.Length - 1
            BackgroundWorker1.ReportProgress((lngCodePtr + 1) * 100 \ strCode.Length, lngCodePtr)
            Select Case strCode.Substring(lngCodePtr, 1)
                Case ">"
                    lngPointer += 1
                    If lngPointer > UBound(bytArray) Then
                        ReDim Preserve bytArray(0 To UBound(bytArray) + 1)
                    End If
                Case "<"
                    lngPointer -= 1
                    If lngPointer < 0 Then
                        ReDim Preserve bytArray(0 To UBound(bytArray) + 1)
                        lngPointer = UBound(bytArray)
                    End If
                Case "+"
                    Try
                        bytArray(lngPointer) += 1
                    Catch ex As Exception
                        bytArray(lngPointer) = 0
                    End Try
                Case "-"
                    Try
                        bytArray(lngPointer) -= 1
                    Catch ex As Exception
                        bytArray(lngPointer) = 255
                    End Try
                Case "["
                    If bytArray(lngPointer) = 0 Then
                        lngCodePtr = strCode.IndexOf("]", CInt(lngCodePtr))
                        If lngCodePtr = -1 Then
                            lngCodePtr = strCode.IndexOf("]")
                        End If
                        If lngCodePtr = -1 Then
                            MsgBox("Unmatched [", MsgBoxStyle.Exclamation, "Error!")
                            Close()
                        End If
                    End If
                Case "]"
                    If bytArray(lngPointer) <> 0 Then
                        Dim lngSave As Long = lngCodePtr
                        Do Until strCode.Chars(lngCodePtr) = "["
                            lngCodePtr = lngCodePtr - 1 Mod strCode.Length
                            If lngCodePtr = lngSave Then
                                MsgBox("Unmatched ]", MsgBoxStyle.Exclamation, "Error!")
                                Close()
                            End If
                        Loop
                    End If
                Case ","
                    Try
                        bytArray(lngPointer) = Asc(InputBox("Character?").Substring(0, 1))
                    Catch ex As Exception
                    End Try
                Case "."
                    BackgroundWorker1.ReportProgress((lngCodePtr + 1) * 100 \ strCode.Length, ChrW(bytArray(lngPointer)))
            End Select
        Next
    End Sub

    Private Sub frmRun_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BackgroundWorker1.RunWorkerAsync()
    End Sub
   
    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As System.Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        If TypeOf e.UserState Is Long Then
            lblCurrentCommand.Text = strCode.Substring(e.UserState, 1)
            lblPointer.Text = lngPointer
        Else
            txtOutput.Text += e.UserState
        End If
    End Sub
End Class